PYTHON(10 April, 1998)

NAME
python - an interpreted, interactive, object-oriented programming language

SYNOPSIS
python [ -d ] [ -i ] [ -O ] [ -S ] [ -t ] [ -u ] [ -v ] [ -x ] [ -X ]
       [ -c command | script | - ] [ arguments ]

DESCRIPTION
Python is an interpreted, interactive, object-oriented programming language that combines remarkable power with very clear syntax. For an introduction to programming in Python you are referred to the Python Tutorial. The Python Library Reference documents built-in and standard types, constants, functions and modules. Finally, the Python Reference Manual describes the syntax and semantics of the core language in (perhaps too) much detail.

Python's basic power can be extended with your own modules written in C or C++. On most systems such modules may be dynamically loaded. Python is also adaptable as an extension language for existing applications. See the internal documentation for hints.

COMMAND LINE OPTIONS

-d  Turn on parser debugging output (for wizards only, depending on compilation options).

-i  When a script is passed as first argument or the -c option is used, enter interactive mode after executing the script or the command. It does not read the $PYTHONSTARTUP file. This can be useful to inspect global variables or a stack trace when a script raises an exception.

-O  Turn on basic optimizations. This changes the filename extension for compiled (bytecode) files from .pyc to pyo.

-S  Disable the import of the module site and the site-dependent manipulations of sys.path that it entails.

-t  Issue a warning when a source file mixes tabs and spaces for indentation in a way that makes it depend on the worth of a tab expressed in spaces. Issue an error when the option is given twice.

-u  Force stdin, stdout and stderr to be totally unbuffered.

-v  Print a message each time a module is initialized, showing the place (filename or built-in module) from which it is loaded.

-x  Skip the first line of the source. This is intended for a DOS specific hack only. Warning: the line numbers in error messages will be off by one!

-X  Make the standard exceptions strings instead of classes. Use for backward compatibility with old code only.

-c command
    Specify the command to execute (see next section). This terminates the option list (following options are passed as arguments to the command).

INTERPRETER INTERFACE
The interpreter interface resembles that of the UNIX shell: when called with standard input connected to a tty device, it prompts for commands and executes them until an EOF is read; when called with a file name argument or with a file as standard input, it reads and executes a script from that file; when called with -c command, it executes the Python statement(s) given as command. Here command may contain multiple statements separated by newlines. Leading whitespace is significant in Python statements! In non-interactive mode, the entire input is parsed befored it is executed.

If available, the script name and additional arguments thereafter are passed to the script in the Python variable sys.argv , which is a list of strings (you must first import sys to be able to access it). If no script name is given, sys.argv is empty; if -c is used, sys.argv[0] contains the string '-c'. Note that options interpreted by the Python interpreter itself are not placed in sys.argv.

In interactive mode, the primary prompt is `>>>'; the second prompt (which appears when a command is not complete) is `...'. The prompts can be changed by assignment to sys.ps1 or sys.ps2. The interpreter quits when it reads an EOF at a prompt. When an unhandled exception occurs, a stack trace is printed and control returns to the primary prompt; in non-interactive mode, the interpreter exits after printing the stack trace. The interrupt signal raises the KeyboardInterrupt exception; other UNIX signals are not caught (except that SIGPIPE is sometimes ignored, in favor of the IOError exception). Error messages are written to stderr.

FILES AND DIRECTORIES
These are subject to difference depending on local installation conventions:

/usr/local/bin/python
    Recommended location of the interpreter.

/usr/local/lib/python<version>
    Recommended location of the directory containing the standard modules.

ENVIRONMENT VARIABLES

PYTHONHOME
    Change the location of the standard Python libraries. By default, the libraries are searched in <prefix>/lib/python<version> and <exec_prefix>/lib/python<version>, where <prefix> and <exec_prefix> are installation-dependent directories, both defaulting to /usr/local. When $PYTHONHOME is set to a single directory, its value replaces both <prefix> and <exec_prefix>. To specify different values for these, set $PYTHONHOME to <prefix>:<exec_prefix>.

PYTHONPATH
    Augments the default search path for module files. The format is the same as the shell's $PATH: one or more directory pathnames separated by colons. Non-existant directories are silently ignored. The default search path is installation dependent, but generally begins with <prefix>/lib/python<version> (see PYTHONHOME below). The default search path is always appended to $PYTHONPATH. If a script argument is given, the directory containing the script is inserted in the path in front of $PYTHONPATH. The search path can be manipulated from within a Python program as the variable sys.path .

PYTHONSTARTUP
    If this is the name of a readable file, the Python commands in that file are executed before the first prompt is displayed in interactive mode. The file is executed in the same name space where interactive commands are executed so that objects defined or imported in it can be used without qualification in the interactive session. You can also change the prompts sys.ps1 and sys.ps2 in this file.

PYTHONDEBUG
    If this is set to a non-empty string it is equivalent to specifying the -d option.

PYTHONINSPECT
    If this is set to a non-empty string it is equivalent to specifying the -i option.

PYTHONUNBUFFERED
    If this is set to a non-empty string it is equivalent to specifying the -u option.

PYTHONVERBOSE
    If this is set to a non-empty string it is equivalent to specifying the -v option.

SEE ALSO
Python Tutorial
Python Library Reference
Python Reference Manual

AUTHOR
Guido van Rossum
CNRI
1895 Preston White Drive
Reston, VA 20191
USA

E-mail: guido@cnri.reston.va.us, guido@python.org

And a cast of thousands.

INTERNET RESOURCES
Web site: http://www.python.org
FTP site: ftp://ftp.python.org
Newsgroup: comp.lang.python

COPYRIGHT
Copyright 1991-1995 by Stichting Mathematisch Centrum, Amsterdam, The Netherlands.

    All Rights Reserved

Permission to use, copy, modify, and distribute this software and its documentation for any purpose and without fee is hereby granted, provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice appear in supporting documentation, and that the names of Stichting Mathematisch Centrum or CWI or Corporation for National Research Initiatives or CNRI not be used in advertising or publicity pertaining to distribution of the software without specific, written prior permission. While CWI is the initial source for this software, a modified version is made available by the Corporation for National Research Initiatives (CNRI) at the Internet address ftp://ftp.python.org. STICHTING MATHEMATISCH CENTRUM AND CNRI DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL STICHTING MATHEMATISCH CENTRUM OR CNRI BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.